<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OTA_VehRateRuleRQRentalInfoRateQualifier StructType
 * @package Dg
 * @subpackage Structs
 */
class DgOTA_VehRateRuleRQRentalInfoRateQualifier extends AbstractStructBase
{
    /**
     * The TravelPurpose
     * @var string
     */
    public $TravelPurpose;
    /**
     * The RateCategory
     * @var string
     */
    public $RateCategory;
    /**
     * The CorpDiscountNmbr
     * @var string
     */
    public $CorpDiscountNmbr;
    /**
     * The RateQualifier
     * @var string
     */
    public $RateQualifier;
    /**
     * The RatePeriod
     * @var string
     */
    public $RatePeriod;
    /**
     * The GuaranteedInd
     * @var bool
     */
    public $GuaranteedInd;
    /**
     * The RateAuthorizationCode
     * @var string
     */
    public $RateAuthorizationCode;
    /**
     * The VendorRateID
     * @var string
     */
    public $VendorRateID;
    /**
     * The RateModifiedInd
     * @var bool
     */
    public $RateModifiedInd;
    /**
     * Constructor method for OTA_VehRateRuleRQRentalInfoRateQualifier
     * @uses DgOTA_VehRateRuleRQRentalInfoRateQualifier::setTravelPurpose()
     * @uses DgOTA_VehRateRuleRQRentalInfoRateQualifier::setRateCategory()
     * @uses DgOTA_VehRateRuleRQRentalInfoRateQualifier::setCorpDiscountNmbr()
     * @uses DgOTA_VehRateRuleRQRentalInfoRateQualifier::setRateQualifier()
     * @uses DgOTA_VehRateRuleRQRentalInfoRateQualifier::setRatePeriod()
     * @uses DgOTA_VehRateRuleRQRentalInfoRateQualifier::setGuaranteedInd()
     * @uses DgOTA_VehRateRuleRQRentalInfoRateQualifier::setRateAuthorizationCode()
     * @uses DgOTA_VehRateRuleRQRentalInfoRateQualifier::setVendorRateID()
     * @uses DgOTA_VehRateRuleRQRentalInfoRateQualifier::setRateModifiedInd()
     * @param string $travelPurpose
     * @param string $rateCategory
     * @param string $corpDiscountNmbr
     * @param string $rateQualifier
     * @param string $ratePeriod
     * @param bool $guaranteedInd
     * @param string $rateAuthorizationCode
     * @param string $vendorRateID
     * @param bool $rateModifiedInd
     */
    public function __construct($travelPurpose = null, $rateCategory = null, $corpDiscountNmbr = null, $rateQualifier = null, $ratePeriod = null, $guaranteedInd = null, $rateAuthorizationCode = null, $vendorRateID = null, $rateModifiedInd = null)
    {
        $this
            ->setTravelPurpose($travelPurpose)
            ->setRateCategory($rateCategory)
            ->setCorpDiscountNmbr($corpDiscountNmbr)
            ->setRateQualifier($rateQualifier)
            ->setRatePeriod($ratePeriod)
            ->setGuaranteedInd($guaranteedInd)
            ->setRateAuthorizationCode($rateAuthorizationCode)
            ->setVendorRateID($vendorRateID)
            ->setRateModifiedInd($rateModifiedInd);
    }
    /**
     * Get TravelPurpose value
     * @return string|null
     */
    public function getTravelPurpose()
    {
        return $this->TravelPurpose;
    }
    /**
     * Set TravelPurpose value
     * @param string $travelPurpose
     * @return \dgsoft\StructType\DgOTA_VehRateRuleRQRentalInfoRateQualifier
     */
    public function setTravelPurpose($travelPurpose = null)
    {
        // validation for constraint: string
        if (!is_null($travelPurpose) && !is_string($travelPurpose)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($travelPurpose)), __LINE__);
        }
        $this->TravelPurpose = $travelPurpose;
        return $this;
    }
    /**
     * Get RateCategory value
     * @return string|null
     */
    public function getRateCategory()
    {
        return $this->RateCategory;
    }
    /**
     * Set RateCategory value
     * @param string $rateCategory
     * @return \dgsoft\StructType\DgOTA_VehRateRuleRQRentalInfoRateQualifier
     */
    public function setRateCategory($rateCategory = null)
    {
        // validation for constraint: string
        if (!is_null($rateCategory) && !is_string($rateCategory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rateCategory)), __LINE__);
        }
        $this->RateCategory = $rateCategory;
        return $this;
    }
    /**
     * Get CorpDiscountNmbr value
     * @return string|null
     */
    public function getCorpDiscountNmbr()
    {
        return $this->CorpDiscountNmbr;
    }
    /**
     * Set CorpDiscountNmbr value
     * @param string $corpDiscountNmbr
     * @return \dgsoft\StructType\DgOTA_VehRateRuleRQRentalInfoRateQualifier
     */
    public function setCorpDiscountNmbr($corpDiscountNmbr = null)
    {
        // validation for constraint: string
        if (!is_null($corpDiscountNmbr) && !is_string($corpDiscountNmbr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($corpDiscountNmbr)), __LINE__);
        }
        $this->CorpDiscountNmbr = $corpDiscountNmbr;
        return $this;
    }
    /**
     * Get RateQualifier value
     * @return string|null
     */
    public function getRateQualifier()
    {
        return $this->RateQualifier;
    }
    /**
     * Set RateQualifier value
     * @param string $rateQualifier
     * @return \dgsoft\StructType\DgOTA_VehRateRuleRQRentalInfoRateQualifier
     */
    public function setRateQualifier($rateQualifier = null)
    {
        // validation for constraint: string
        if (!is_null($rateQualifier) && !is_string($rateQualifier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rateQualifier)), __LINE__);
        }
        $this->RateQualifier = $rateQualifier;
        return $this;
    }
    /**
     * Get RatePeriod value
     * @return string|null
     */
    public function getRatePeriod()
    {
        return $this->RatePeriod;
    }
    /**
     * Set RatePeriod value
     * @uses \dgsoft\EnumType\DgOTA_VehRateRuleRQRentalInfoRateQualifierRatePeriod::valueIsValid()
     * @uses \dgsoft\EnumType\DgOTA_VehRateRuleRQRentalInfoRateQualifierRatePeriod::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $ratePeriod
     * @return \dgsoft\StructType\DgOTA_VehRateRuleRQRentalInfoRateQualifier
     */
    public function setRatePeriod($ratePeriod = null)
    {
        // validation for constraint: enumeration
        if (!\dgsoft\EnumType\DgOTA_VehRateRuleRQRentalInfoRateQualifierRatePeriod::valueIsValid($ratePeriod)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $ratePeriod, implode(', ', \dgsoft\EnumType\DgOTA_VehRateRuleRQRentalInfoRateQualifierRatePeriod::getValidValues())), __LINE__);
        }
        $this->RatePeriod = $ratePeriod;
        return $this;
    }
    /**
     * Get GuaranteedInd value
     * @return bool|null
     */
    public function getGuaranteedInd()
    {
        return $this->GuaranteedInd;
    }
    /**
     * Set GuaranteedInd value
     * @param bool $guaranteedInd
     * @return \dgsoft\StructType\DgOTA_VehRateRuleRQRentalInfoRateQualifier
     */
    public function setGuaranteedInd($guaranteedInd = null)
    {
        // validation for constraint: boolean
        if (!is_null($guaranteedInd) && !is_bool($guaranteedInd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($guaranteedInd)), __LINE__);
        }
        $this->GuaranteedInd = $guaranteedInd;
        return $this;
    }
    /**
     * Get RateAuthorizationCode value
     * @return string|null
     */
    public function getRateAuthorizationCode()
    {
        return $this->RateAuthorizationCode;
    }
    /**
     * Set RateAuthorizationCode value
     * @param string $rateAuthorizationCode
     * @return \dgsoft\StructType\DgOTA_VehRateRuleRQRentalInfoRateQualifier
     */
    public function setRateAuthorizationCode($rateAuthorizationCode = null)
    {
        // validation for constraint: string
        if (!is_null($rateAuthorizationCode) && !is_string($rateAuthorizationCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rateAuthorizationCode)), __LINE__);
        }
        $this->RateAuthorizationCode = $rateAuthorizationCode;
        return $this;
    }
    /**
     * Get VendorRateID value
     * @return string|null
     */
    public function getVendorRateID()
    {
        return $this->VendorRateID;
    }
    /**
     * Set VendorRateID value
     * @param string $vendorRateID
     * @return \dgsoft\StructType\DgOTA_VehRateRuleRQRentalInfoRateQualifier
     */
    public function setVendorRateID($vendorRateID = null)
    {
        // validation for constraint: string
        if (!is_null($vendorRateID) && !is_string($vendorRateID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vendorRateID)), __LINE__);
        }
        $this->VendorRateID = $vendorRateID;
        return $this;
    }
    /**
     * Get RateModifiedInd value
     * @return bool|null
     */
    public function getRateModifiedInd()
    {
        return $this->RateModifiedInd;
    }
    /**
     * Set RateModifiedInd value
     * @param bool $rateModifiedInd
     * @return \dgsoft\StructType\DgOTA_VehRateRuleRQRentalInfoRateQualifier
     */
    public function setRateModifiedInd($rateModifiedInd = null)
    {
        // validation for constraint: boolean
        if (!is_null($rateModifiedInd) && !is_bool($rateModifiedInd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($rateModifiedInd)), __LINE__);
        }
        $this->RateModifiedInd = $rateModifiedInd;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgOTA_VehRateRuleRQRentalInfoRateQualifier
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
